(define (mult-pointwise! uinterp scalarinterp vinterp)
  (let ((s (slot-ref uinterp 'space)))
    (al.for
      (i 0 (math.dimension s))
      (let ((valu (* (_ scalarinterp i) 
                     (_ vinterp i) 
                  )))
        (_! uinterp i valu))))
)
(define (interp-dot-product vinterp winterp)
 (let ((dp 0.0)
       (space-of-first-interpolant (slot-ref vinterp 'space)))
      (al.for (i 0 (math.dimension space-of-first-interpolant))
         (set! dp (+ dp (* (_ vinterp i) (_ winterp i)))))
  dp)
)
(define (interp-component! scalarinterp vectorinterp jcomponent)
   ; sets the value of scalarinterp to be the jcomponent of vectorinterp 
   (let ((space-of-scalar-interpolant (slot-ref scalarinterp 'space)))
      (al.for (ntrpndx 0 (math.dimension space-of-scalar-interpolant))
         (math._! scalarinterp ntrpndx (_ (math._ vectorinterp ntrpndx) 
                                          jcomponent))))
)
